码迷,mamicode.com
首页 > 其他好文 > 详细

hdu 5389 dp类似背包

时间:2015-08-14 19:15:20      阅读:183      评论:0      收藏:0      [点我收藏+]

标签:

http://acm.hdu.edu.cn/showproblem.php?pid=5389
Problem Description
Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft. Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor.  This is the definition of digital root on Wikipedia: The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number is reached. For example, the digital root of 65536 is 7, because 6+5+5+3+6=25 and 2+5=7. In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered X(1X9), the digital root of their identifier sum must be X. For example, players {1,2,6} can get into the door 9, but players {2,3,3} can‘t. There is two doors, numbered A and B. Maybe A=B, but they are two different door. And there is n players, everyone must get into one of these two doors. Some players will get into the door A, and others will get into the door B. For example:  players are {1,2,6}A=9B=1 There is only one way to distribute the players: all players get into the door 9. Because there is no player to get into the door 1, the digital root limit of this door will be ignored. Given the identifier of every player, please calculate how many kinds of methods are there, mod 258280327.
 

Input
The first line of the input contains a single number T, the number of test cases. For each test case, the first line contains three integers nA and B. Next line contains n integers idi, describing the identifier of every player. T100n105n1061A,B,idi9
 

Output
For each test case, output a single integer in a single line, the number of ways that these n players can get into these two doors.
 

Sample Input
4 3 9 1 1 2 6 3 9 1 2 3 3 5 2 3 1 1 1 1 1 9 9 9 1 2 3 4 5 6 7 8 9
 

Sample Output
1 0 10 60

/**
hdu 5389 dp类似背包
题目大意:给出一组数让分成两组,组成两数的数根分别为a和b,那么有多少种分法
解题思路:这题主要是透彻理解数根的求法,我们一个数的数根为各个位上数的和相加模9如果为0则为9,并且两数和的数根等于两数数根和的数根。
           有了这个规律我们可以用类似背包的方法求出。dp[i][j]表示前i个数的数根为j有多少种取法。最后若a和b和的数根为所有数的数根,那么dp[n][a]
           便为答案。此外还要考虑全部放于a和全部放于b的结果。状态转移方程见代码
*/
#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <iostream>
using namespace std;
const int maxn=100500;
const int mod=258280327;

int n,a,b,id[maxn];
int dp[maxn][15];

int get_sum(int x,int y)
{
    int tmp=(x+y)%9;
    if(tmp==0)tmp=9;
    return tmp;
}

int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d%d%d",&n,&a,&b);
        int sum=0;
        for(int i=1;i<=n;i++)
        {
            scanf("%d",&id[i]);
            sum=get_sum(sum,id[i]);
        }
        memset(dp,0,sizeof(dp));
        dp[0][0]=1;
        for(int i=1;i<=n;i++)
        {
            for(int j=0;j<=9;j++)
            {
                dp[i][j]=(dp[i][j]+dp[i-1][j])%mod;
                int ans=get_sum(j,id[i]);
                dp[i][ans]=(dp[i][ans]+dp[i-1][j])%mod;
            }
        }
        int ans=0;
        if(get_sum(a,b)==sum)
        {
            ans+=dp[n][a];
            if(a==sum)ans--;
        }
        if(a==sum)ans++;
        if(b==sum)ans++;
        printf("%d\n",ans%mod);
    }
    return 0;
}


版权声明:本文为博主原创文章,未经博主允许不得转载。

hdu 5389 dp类似背包

标签:

原文地址:http://blog.csdn.net/lvshubao1314/article/details/47664845

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!